Package: BeadDataPackR
Type: Package
Title: Compression of Illumina BeadArray data
Version: 1.65.0
Date: 2018-02-09
Author: Mike Smith, Andy Lynch
Maintainer: Mike Smith <grimbough@gmail.com>
Description: Provides functionality for the compression and decompression of raw bead-level data from the Illumina BeadArray platform.
License: GPL-2
LazyLoad: yes
biocViews: Microarray
VignetteBuilder: knitr
Suggests: BiocStyle, knitr
Imports: stats, utils
git_url: https://git.bioconductor.org/packages/BeadDataPackR
git_branch: devel
git_last_commit: 1ecd28a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:25:42 UTC; biocbuild

decompressBeadData <- function(input, inputPath = ".", outputMask = NULL, outputPath = ".", outputNonDecoded = FALSE, roundValues = TRUE, progressBar = TRUE) {
    
    if(!is.null(outputMask) & length(outputMask) != length(input)) {
        stop("The outputMask argument must either be NULL or\ncontain the same number of entries as the input argument");
    }
    
    for(inputFile in input) {
        message(paste("\nDecompressing", inputFile));
        if(progressBar) {
            pb <- txtProgressBar(style=3)
            setTxtProgressBar(pb, 0.00)
        }
        else {
            pb <- NULL;
        }
        
        ## open connection to the binary file and inform the user
        con <- file(paste(inputPath, inputFile, sep = .Platform$file.sep), "rb");
        
        ## read the header
        header <- readHeader(con);
        ## parse the header to see if the user needs to be informed about outdated versions
        parseHeader(header);
        
        if(is.null(outputMask)) 
            outputMaskUsed <- header$arrayName
        else
            outputMaskUsed <- outputMask[which(input == inputFile)]
        
        ## create a matrix to hold the results
        if(!header$twoChannel) {
            txt <- matrix(ncol = 4, nrow = header$nBeads)
            colnames(txt) <- c("Code", "Grn", "GrnX", "GrnY")
            locs <- matrix(ncol = 3, nrow = header$nBeads);
        }
        else {
            txt <- matrix(ncol = 7, nrow = header$nBeads)
            colnames(txt) <- c("Code", "Grn", "GrnX", "GrnY", "Red", "RedX", "RedY")
            locs <- matrix(ncol = 5, nrow = header$nBeads);
        }
        
        if(progressBar) { setTxtProgressBar(pb, 0.02) }
        
        ## create a counter so we know where in the results matrix we stick the next results
        pos <- 1
        #message("Processing beads");
        for(i in 1:header$nProbeIDs) {
        
            ## update the progress bar
            if(progressBar) {
                if(i %/% 1000)
                    setTxtProgressBar(pb, 0.02 + (0.63 * i/header$nProbeIDs))
            }
            ## first 4 bytes are probeID, second are the number of beads of that type
            storeTmp <- readBin(con, integer(), size = 4, n = 2);
            probeID <- storeTmp[1];
            nbeads <- storeTmp[2];
            posEnd <- pos+nbeads-1
            
            ## fill in the probeIDs and intensities
            txt[pos:posEnd,1] <- rep(probeID, nbeads)
            if( probeID == 0 ) {
                txt[pos:posEnd,2] <- rep(0, nbeads)
                if(header$twoChannel)
                    txt[pos:posEnd,5] <- rep(0, nbeads)
            }
            else {
                txt[pos:posEnd,2] <- readIntensities(con, nbeads = nbeads);
                if(header$twoChannel)
                    txt[pos:posEnd,5] <- readIntensities(con, nbeads = nbeads);
            }
                
            coords <- readCoordinates(con = con, nbeads = nbeads, nBytes = header$nBytes, twoChannel = header$twoChannel, offset = header$useOffset, base2 = header$base2)    

            locs[pos:posEnd, 2:3] <- coords[1:(2*nbeads)];
            if(header$twoChannel) {
                locs[pos:posEnd, 4:5] <- coords[(2*nbeads+1):length(coords)];
            }      

            if(header$indexingMethod) {
                locs[pos:posEnd, 1] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE) * 65536;
                locs[pos:posEnd, 1] <- locs[pos:posEnd, 1] + readBin(con, integer(), size = 2, n = nbeads, signed = FALSE)
            }
            else {
                locs[pos:posEnd, 1] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE)
            }

            ## update the current position
            pos <- pos + nbeads
        }
        ## close the connection
        close(con)

        ## if the red channel are just offsets from the green then correct this
        if(header$useOffset)
            locs[,4:5] <- floor(locs[,2:3]) + locs[,4:5];

        ## insert the coordinates into the txt file
        if(roundValues) {
            txt[,3:4] <- .Call("roundLocsFileValues", as.numeric(locs[, 2:3]), PACKAGE = "BeadDataPackR");
            if(header$twoChannel)
                txt[,6:7] <- .Call("roundLocsFileValues", as.numeric(locs[, 4:5]), PACKAGE = "BeadDataPackR"); 
        }
        else {
            txt[,3:4] <- locs[, 2:3];
            if(header$twoChannel)
                txt[,6:7] <- locs[, 4:5]; 
        }
        
        if(!header$indexingMethod) {
            decoded <- decodeIndices(locs[,1], locs[,2:3], header$nSegs, header$marks, header$coeffs, pb = pb);
            locs[,2:3] <- reformCoordinates(locs[,2:3], header$nSegs, header$marks);
            txt[,3:4] <- reformCoordinates(txt[,3:4], header$nSegs, header$marks);
            locs <- locs[decoded,2:(ncol(locs))]
        }
        else {
            locs <- locs[order(locs[,1]), 2:(ncol(locs))];
        }
 
        ## remove the nondecoded beads if desired
        if( (!outputNonDecoded) & (length(which(txt[,1] == 0))) ) 
            txt <- txt[-which(txt[,1] == 0),]
        
        ## write the output files
        write.table(txt, file = paste(outputPath, paste(outputMaskUsed, ".txt", sep = ""), sep = .Platform$file.sep), sep = "\t", quote = FALSE, row.names = FALSE)
        
        if(progressBar) { setTxtProgressBar(pb, 0.90) };
        
        writeLocsFile(fileName = paste(outputPath, paste(outputMaskUsed, "_Grn.locs", sep = ""), sep = .Platform$file.sep), t(locs[,1:2]), nBeads = header$nBeads);
        if(header$twoChannel) {
            writeLocsFile(fileName = paste(outputPath, paste(outputMaskUsed, "_Red.locs", sep =""), sep = .Platform$file.sep), t(locs[,3:4]), nBeads = header$nBeads);
        }
        
        if(progressBar) {
            setTxtProgressBar(pb, 1);
            close(pb);
        }
    }
}

readCompressedData <- function(inputFile, path = ".", probeIDs = NULL)
{

    ## sort the probeIDs.  The bab file is sorted in increasing numerical order
    if(!is.null(probeIDs))
        probeIDs <- sort(unique(probeIDs));
  
    ## open connection to the binary file
    con <- file(paste(path, inputFile, sep = .Platform$file.sep), "rb");

    ## read the file header
    header <- readHeader(con);

    ## scan through once to find and count the beads we're interested in
    ## only need to do this if probeIDs != NULL
    if(!is.null(probeIDs)) {
        outputCount <- 0;
        for(i in 1:header$nProbeIDs) {

            storeTmp <- readBin(con, integer(), size = 4, n = 2);
            probeID <- storeTmp[1];
            nbeads <- storeTmp[2];
        
            ## are we looking for this probeID?
            if( (is.null(probeIDs)) | (probeID %in% probeIDs) ) {
                outputCount <- outputCount + nbeads;
            }
            ## How many bytes can we now skip?
            inten <- as.logical(probeID) * 2^header$twoChannel * ( (2 * nbeads) + ( ( (nbeads - 1)  %/% 4) + 1) )
            coords <- (2 * header$nBytes * nbeads) - (0^(!header$useOffset) * 2 * nbeads);
            index <- 3^header$indexingMethod * nbeads;
            seek(con = con, where = sum(inten, coords, index), origin = "current");
        }
    }
    else {
        outputCount <- header$nBeads;
    }

    ## reset to the beginning of the file
    seek(con = con, where = 0, origin = "start");
    readHeader(con);

    ## create output matrix and position counter
    output <- matrix(NA, ncol = 3 + (4^header$twoChannel), nrow = outputCount);
    pos <- 1;

    for(i in 1:header$nProbeIDs) {

	storeTmp <- readBin(con, integer(), size = 4, n = 2);
	probeID <- storeTmp[1];
	nbeads <- storeTmp[2];

        if(!is.null(probeIDs))
            probeIDs <- probeIDs[which(probeIDs >= probeID)];

	## if we've already got all the requested probes, quit the loop
	if(!is.null(probeIDs) & !length(probeIDs))
		break;
        
        ## are we looking for this probeID?
        if( (is.null(probeIDs)) | (probeID %in% probeIDs) ) {

            posEnd <- pos + nbeads - 1;

            output[pos:posEnd,1] <- rep(probeID, nbeads);     
            ## only read the intensities if they are there
            if(probeID) {  
                output[pos:posEnd,2] <- readIntensities(con, nbeads = nbeads);
                if(header$twoChannel)
                    output[pos:posEnd,5] <- readIntensities(con, nbeads = nbeads);
            } ## intensities not stored for probeID 0
            else {
                output[pos:posEnd,2] <- rep(0, nbeads);
                if(header$twoChannel) 
                    output[pos:posEnd,5] <- rep(0, nbeads);
            }
                
            coords <- readCoordinates(con = con, nbeads = nbeads, nBytes = header$nBytes, twoChannel = header$twoChannel, offset = header$useOffset, base2 = header$base2)

            output[pos:posEnd,3:4] <- coords[1:(2*nbeads)];
            if(header$twoChannel)
                output[pos:posEnd,6:7] <- coords[(2*nbeads+1):length(coords)];
                
            ## skip the locs file index, we don't need it here
            seek(con = con, where = nbeads * 3^header$indexingMethod, origin = "current");
            ## we do want it after all!
            #if(header$indexingMethod) {
            #    output[pos:posEnd, ncol(output)] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE) * 65536;
            #    output[pos:posEnd, ncol(output)] <- output[pos:posEnd, ncol(output)] + readBin(con, integer(), size = 2, n = nbeads, signed = FALSE)
            #}
            #else {
            #    output[pos:posEnd, ncol(output)] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE)
            #}        

            ## increase the position counter
            pos <- pos + nbeads;
        }
        else { ## We don't want this probe
            ## How many bytes can we skip?
            inten <- as.logical(probeID) * 2^header$twoChannel * ( (2 * nbeads) + ( ( (nbeads - 1)  %/% 4) + 1) )
            coords <- (2 * header$nBytes * nbeads) - (0^(!header$useOffset) * 2 * nbeads);
            index <- 3^header$indexingMethod * nbeads;
            seek(con = con, where = sum(inten, coords, index), origin = "current");
        }
    }
    ## close the bab file
    close(con);
    
    ## round the coordinates to match the text file
    output[,3:4] <- matrix(.Call("roundLocsFileValues", output[,3:4], PACKAGE = "BeadDataPackR"), ncol = 2);
    if(header$twoChannel)
        output[,6:7] <- matrix(.Call("roundLocsFileValues", output[,6:7], PACKAGE = "BeadDataPackR"), ncol = 2);
    

    if(!nrow(output)) {
	## tell the user if no probe IDs matched
        message("No matching probe IDs");
        output <- NULL;
    }
    else {
        if(header$twoChannel) {
            colnames(output) <- c('Code','Grn','GrnX','GrnY','Red','RedX','RedY')
        } 
        else {
            colnames(output) <- c('Code','Grn','GrnX','GrnY')
        }
    }
    return(output);
}

extractLocsFile <- function(inputFile, path = ".") {
##
## Function will extract only the .locs file from a .bab and return it as a matrix
##
    
    ## open connection to the binary file
    con <- file(paste(path, inputFile, sep = .Platform$file.sep), "rb");

    ## read the file header
    header <- readHeader(con);

    ## create output matrix and position counter
    locs <- matrix(NA, ncol = 2 + (3^header$twoChannel), nrow = header$nBeads);
    pos <- 1
    
    for(i in 1:header$nProbeIDs) {

        ## skip everything other than the locs information
        storeTmp <- readBin(con, integer(), size = 4, n = 2);
        probeID <- storeTmp[1];
        nbeads <- storeTmp[2];
        posEnd <- pos + nbeads - 1;
        
        ## How many bytes can we now skip?
        inten <- as.logical(probeID) * 2^header$twoChannel * ( (2 * nbeads) + ( ( (nbeads - 1)  %/% 4) + 1) );
        seek(con = con, where = inten, origin = "current");
        
        coords <- readCoordinates(con = con, nbeads = nbeads, nBytes = header$nBytes, twoChannel = header$twoChannel, offset = header$useOffset, base2 = header$base2)
        
        locs[pos:posEnd,2:3] <- coords[1:(2*nbeads)];
        if(header$twoChannel)
            locs[pos:posEnd,4:5] <- coords[(2*nbeads+1):length(coords)];
        
        ## read the locs file index
        if(header$indexingMethod) {
            locs[pos:posEnd, 1] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE) * 65536;
            locs[pos:posEnd, 1] <- locs[pos:posEnd, 1] + readBin(con, integer(), size = 2, n = nbeads, signed = FALSE)
        }
        else {
            locs[pos:posEnd, 1] <- readBin(con, integer(), size = 1, n = nbeads, signed = FALSE)
        }

        ## increase the position counter
        pos <- pos + nbeads;        

    }
    ## close the bab file
    close(con);
    
    ## if the red channel are just offsets from the green then correct this
    if(header$useOffset)
        locs[,4:5] <- floor(locs[,2:3]) + locs[,4:5];
    
    ## reorder into locs file order
    if(!header$indexingMethod) {
        decoded <- decodeIndices(locs[,1], locs[,2:3], header$nSegs, header$marks, header$coeffs, pb = NULL);
        locs[,2:3] <- reformCoordinates(locs[,2:3], header$nSegs, header$marks);
        locs <- locs[decoded,2:(ncol(locs))]
    }
    else {
        locs <- locs[order(locs[,1]), 2:(ncol(locs))];
    }

    return(locs);   
}

createIndices <- function(locs, nrow = NULL, ncol = NULL, pb = NULL) 
{
    
    ## used during compression to create an index between 0 & 14 in both
    ## the x&y directions for each bead.  This combined with the predicted
    ## coordinates should allow the grid reconstruction.
    
    ## if we haven't been give the grid size, try to calculate it
    if(is.null(nrow) || is.null(ncol)) {
        segsize <- which((locs[-1,1]-locs[-length(locs[,1]),1])>100)[1]
        
        ## if there is only one segment (e.g. 1M arrays) when need to specify that
        if(is.na(segsize))
            segsize <- nrow(locs);
        
        seg <- locs[1:segsize,]
        tempy <- which(seg[-length(seg[,2]),2]>seg[-1,2])
        nrow <- as.numeric(names(sort(table(tempy[-1]-tempy[-length(tempy)]),decreasing=T))[1]) 
        ncol <- segsize/nrow
    }

    nSegs <- nrow(locs) / (nrow * ncol);

    res <- list()

    ## store the max ycoord of the previous segment
    prevMaxY <- 0
  
    ## process each segment at a time
    for(i in 1:nSegs ) {
    
        if(!is.null(pb))
            setTxtProgressBar(pb, 0.5 + (0.1 * i / nSegs));
      
        seg <- locs[( (nrow * ncol * (i-1) ) + 1):(nrow * ncol * i),  ]
        grid <- cbind(rep(0:(ncol-1), each = nrow), rep(0:(nrow-1), ncol))

        ## adjust for overlapping segments
        ## store the adjust coords and grid indices
        if( floor(min(seg[,2])) < prevMaxY ) {
            #message("Overlapping segment found! Adjusting...");
            shift <- prevMaxY - floor(min(seg[,2])) + 1
            seg[,2] <- seg[,2] + shift
            res[[4*i-1]] <- c(shift, floor(min(seg[,2])), ceiling(max(seg[,2])));
        }
        else {
            res[[4*i-1]] <- c(0, floor(min(seg[,2])), ceiling(max(seg[,2])));
        }
        prevMaxY <- ceiling(max(seg[,2]))
        res[[(4*i)-3]] <- seg
        res[[(4*i)-2]] <- grid %% 15

        ## fit the lm to the adjusted coords and store the coefficients
        lmX <- lm(grid[,1] ~ 1 + seg[,1] + seg[,2])
        lmY <- lm(grid[,2] ~ 1 + seg[,1] + seg[,2])
        
        ## check whether mod 15 encoding is going to be enough
        predX <- round(lmX$coefficients[1] + seg[,1] * lmX$coefficients[2] + seg[,2] * lmX$coefficients[3])
        predY <- round(lmY$coefficients[1] + seg[,1] * lmY$coefficients[2] + seg[,2] * lmY$coefficients[3])
        if( (any(abs(predX - grid[,1]) > 7)) | (any(abs(predY - grid[,2]) > 7)) ) {
            if(!is.null(pb))
                close(pb);
            stop("There appear to be some badly positioned bead centres\nIt is recommended to use the fullLocsIndex argument for this array", call. = FALSE);
        }
        
        res[[4*i]] <- c(lmX$coefficients, lmY$coefficients)
    }

    resList <- list();
    resList[[1]] <- res[[1]];
    resList[[2]] <- res[[2]];
    resList[[3]] <- res[[3]];
    resList[[4]] <- res[[4]];
    if(nSegs > 1) {
        for(i in seq(5, length(res), 4)) {
            resList[[1]] <- rbind(resList[[1]], res[[i]]);
            resList[[2]] <- rbind(resList[[2]], res[[i+1]]);
            resList[[3]] <- c(resList[[3]], res[[i+2]]);
            resList[[4]] <- c(resList[[4]], res[[i+3]]);
        }
    }
    resList[[5]] <- c(nSegs, nrow, ncol, nrow * ncol);
    return(resList);
}



decodeIndices <- function(indices, locs, nSegs, marks, coefficients, pb = NULL) {

    ## used during decompression
    ## decode the 0-14 indicies into one for the whole locs file
    ## indices are 8bit numbers and need to be transformed into 2 4bit numbers
    ## input locs are shifted coords, not the originals

    ## convert the indices to 2 numbers
    indices <- .Call("decodeInd", as.integer(indices), PACKAGE = "BeadDataPackR");

    res <- NULL
    ## loop over each segment
    for(i in 1:nSegs) {
    
        if(!is.null(pb))
            setTxtProgressBar(pb, 0.65 + (0.1 * i / nSegs));
        
        ## extract the beads in this segment
        idx <- which( (locs[,2] >= marks[(3 * i) - 1]) & (locs[,2] <= marks[(3 * i)] ) )
        seg <- cbind(locs[idx,], indices[idx,])

        ## get the model coefficiets for this segment
        coeff <- coefficients[(6*i-5):(6*i)]
        
        ## obtain the predicted coordinates 
        predX <- round(coeff[1] + seg[,1] * coeff[2] + seg[,2] * coeff[3])
        predY <- round(coeff[4] + seg[,1] * coeff[5] + seg[,2] * coeff[6])
        #modX <- predX %% 15
        #modY <- predY %% 15

        predX2 <- .Call("adjustValues", matrix(as.integer(cbind(predX, seg[,3])), ncol = 2), PACKAGE = "BeadDataPackR");
        predY2 <- .Call("adjustValues", matrix(as.integer(cbind(predY, seg[,4])), ncol = 2), PACKAGE = "BeadDataPackR");
        trueIdx <- .Call("returnTrueIndex", as.integer(predX2), as.integer(predY2), as.integer(max(predY2)+1), PACKAGE = "BeadDataPackR");
        
        res <- c(res, idx[order(trueIdx)] );
    }
    return(res);
}

reduceIndexSize <- function(index) {

    ## transform a 32bit integer into 8bit and 16bit pieces that can be multiplied
    ## this reduces the index size by one byte per bead
  
    return(c((index-1) %/% 65536, (index-1) %% 65536));
}

readHeader <- function(con) {

  ## read the header information and return as a list
  header <- list();
  header$version <- readBin(con, integer(), size = 1);
  header$nBeads <- readBin(con, integer(), size = 4);
  header$nProbeIDs <- readBin(con, integer(), size = 4);
  header$nBytes <- readBin(con, integer(), size = 1);
  header$twoChannel <- readBin(con, integer(), size = 1);
  header$useOffset <- readBin(con, integer(), size = 1);
  header$base2 <- readBin(con, integer(), size = 1);
  header$indexingMethod <- readBin(con, integer(), size = 1);
  if(!header$indexingMethod) {
    header$nSegs <- readBin(con, integer(), size = 1);
    header$marks <- readBin(con, integer(), size = 2, n = header$nSegs * 3);
    header$coeffs <- readBin(con, numeric(), size = 4, n = header$nSegs * 6);
  }
  header$arrayName <- readBin(con, character());
  return(header);
}

parseHeader <- function(header) {
    ## some bug fixes have been followed by increments in version numbers.
    ## this function will inform the user if data with known faults is encountered
    
    ## version 1 + fullLocsIndexing scrambled the order of the .locs file
    if( (header$version == 1) & (header$indexingMethod) ) {
        message("
Early versions of BeadDataPackR incorrectly encoded the order of the input .locs file when the 'fullLocsIndex' argument was used, resulting in an incorrect .locs file on restoration. 
The .txt file was unaffected by this bug.
This has been corrected in BeadDataPackR v1.1.7 onwards")
    }
    
}

applyFlags <- function(inten) {

    ## apply the flags to each intensity
  
    inten[1] <- inten[1] + (inten[2] * 65536)
    if(inten[3])
        inten[1] <- -inten[1]

    return(inten[1])
}

readIntensities <- function(con, nbeads)
{
    inten <- readBin(con, integer(), size = 2, signed = FALSE, n = nbeads)
    flags <- readBin(con, integer(), size = 1, signed = TRUE, n = ( ( (nbeads-1) %/% 4 ) + 1 ) )

    ## get the bits we're interested in
    flags2 <- .Call("int2Bits", as.integer(flags), PACKAGE = "BeadDataPackR");
    flags3 <- matrix(c(inten, flags2[1:length(inten),]), ncol = 3)

    inten <- .Call("applyFlags", flags3, PACKAGE = "BeadDataPackR")
    return(inten)
}

readCoordinates <- function(con, nbeads, nBytes, twoChannel, offset = FALSE, base2 = FALSE)
{

    if(nBytes == (4 * (2^twoChannel)) ) {
        coords <- readBin(con, double(), size = 4, n = 2 * (2^twoChannel) * nbeads)
    }
    else {

        ## read the integer parts.  Grn first, then Red, which may be using offsets
        coords <- readBin(con, integer(), size = 2, n = 2*nbeads, signed = TRUE);
        if(twoChannel) {
            coords <- c(coords, readBin(con, integer(), size = 2^(!offset), n = 2*nbeads, signed = TRUE));
        }
        
        if(nBytes) {
            
            ## calculate the number of bits required for each coordinate
            nBits <- 2 * 2^(!twoChannel) * nBytes;
            
            ## set a multiplier based on base 2 or base 10
            if(base2)
                div <- 2^nBits
            else
                div <- 10^(min(which(2^nBits < 10^(1:5))));
            
            ## read the stored fractional parts
            tmp <- readBin(con, integer(), size = 1, n = nBytes * nbeads, signed = FALSE);
            ## convert them to bits
            bits <- matrix(as.integer(sapply(tmp, intToBits)[1:8,]), nrow = nBits);
            ## convert back into 2/4 integers
            frac <- .Call("bitsToInts", bits, PACKAGE = "BeadDataPackR") / div;
            coords <- coords + frac;
        }
    }

  return(coords);
}

combineFiles <- function(txt, locsGrn, locsRed = NULL, pb = NULL, verbose = FALSE) {
 
    locsRounded <- matrix(.Call("roundLocsFileValues", locsGrn, PACKAGE = "BeadDataPackR"), ncol = 2);
    txtFileCoords <- txt[,3:4];
   
    locs <- cbind(1:nrow(locsGrn), locsGrn, locsRed)

    ## add an index column to the txt file
    txtFileCoords <- cbind(1:nrow(txtFileCoords), txtFileCoords);
    
    locsKeyMult <- locsRounded[,1] * locsRounded[,2];
    txtKeyMult <- txtFileCoords[,2] * txtFileCoords[,3];
    
    if(!is.null(pb))
        setTxtProgressBar(pb, 0.20);
    
    ## if we find a duplicate entry then it may be due to the multiplication
    if(any(duplicated(locsKeyMult))) {
        locsKeyDiv <- locsRounded[,1] / locsRounded[,2];
        txtKeyDiv <- txtFileCoords[,2] / txtFileCoords[,3];
        idx <- which( (locsKeyDiv %in% txtKeyDiv) & (locsKeyMult %in% txtKeyMult) )
    }
    else {
        idx <- which( locsKeyMult %in% txtKeyMult );   
    }

    ## if there's still some duplicated use string concatonation. It's really slow!!
    if(length(idx) != nrow(txtFileCoords)) {
        if(verbose) message("Using string concatenation");
        locsKey <- paste(locsRounded[,1], locsRounded[,2]);
        txtKey <- paste(txtFileCoords[,2], txtFileCoords[,3]);
        idx <- which(locsKey %in% txtKey);

        ## with iScan we can still get perfect duplicate coordinates
        ## currently we remove them and make them non-decoded
        if(length(idx) > length(txtKey)) {
            duplicateList <- removeDuplicates(locsKey, txtKey);
            ## remove any from the txt file coordinates which have multiple matches in the locs file
            txtKey <- txtKey[ -duplicateList[[2]] ];
            txtFileCoords <- txtFileCoords[ -duplicateList[[2]], ];
            txt <- txt[ -duplicateList[[2]], ];
            idx <- which(locsKey %in% txtKey);
        }
    }
    
    if(!is.null(pb))
        setTxtProgressBar(pb, 0.30);
    
    ## find which are in both file and remove those that aren't from the locsCoords
    nonDeCoords <- locs[-idx,];
    locsFileCoords <- cbind( locs[,1], locsRounded, locs[,2:ncol(locs)] )[idx,];

    if(!is.null(pb))
        setTxtProgressBar(pb, 0.40);
    
    ## order the two files by the rounded x and y coords
    if(verbose) message("Reordering");
    txtFileCoords <- txtFileCoords[order(txtFileCoords[,2], txtFileCoords[,3]),]
    locsFileCoords <- locsFileCoords[order(locsFileCoords[,2], locsFileCoords[,3]),]

    txtFileCoords <- cbind(txtFileCoords, locsFileCoords[,c(1, 4:ncol(locsFileCoords) )]);

    ## combine 
    if(is.null(locsRed)) {
        txtFileCoords <- txtFileCoords[order(txtFileCoords[,1]), c(5,6,4)];
        txtFileCoords <- cbind(txt[,1:2], txtFileCoords);
        undecoded <- cbind(rep(0, nrow(nonDeCoords)), rep(0, nrow(nonDeCoords)), nonDeCoords[,c(2,3,1)])
        result <- rbind(undecoded, as.matrix(txtFileCoords));
        colnames(result) <- c("Code", "Grn", "GrnX", "GrnY", "LocsIdx") 
    }
    else {
        txtFileCoords <- txtFileCoords[order(txtFileCoords[,1]), c(5:8, 4)];
        txtFileCoords <- cbind(txt[,1:2], txtFileCoords[,1:2], txt[,5], txtFileCoords[,3:5])
        undecoded <- cbind(rep(0, nrow(nonDeCoords)), rep(0, nrow(nonDeCoords)), nonDeCoords[,2:3], rep(0, nrow(nonDeCoords)), nonDeCoords[,c(4:5, 1)])
        result <- rbind(undecoded, as.matrix(txtFileCoords));
        colnames(result) <- c("Code", "Grn", "GrnX", "GrnY", "Red", "RedX", "RedY", "LocsIdx")  
    }

    return(result);
}

removeDuplicates <- function(locsKey, txtKey) { 
    locsDup <- c(which(duplicated(locsKey)), which(duplicated(locsKey, fromLast = TRUE)))
    txtDup <- which(txtKey %in% locsKey[locsDup])
    return(list(locsDup, txtDup));
}

writeBabHeader <- function(con, version, combined, nBytes, twoChannel, useOffset, base2, indexingMethod, res)
## write the file header
{
    writeBin(as.integer(version), con = con, size = 1);
    writeBin(as.integer(nrow(combined)), con = con, size = 4)
    writeBin(as.integer(length(unique(combined[,1]))), con = con, size = 4)
    writeBin(as.integer(c(nBytes, twoChannel, useOffset, base2)), con = con, size = 1);
    writeBin(as.integer(indexingMethod), con = con, size = 1);
    ## if we're using the fitted grid, record the number of segments and the segment information
    if(!indexingMethod) {
        ## number of segments
        writeBin(as.integer(res[[5]][1]), con = con, size = 1);
        writeBin(as.integer(res[[3]]), con = con, size = 2);
        writeBin(as.numeric(res[[4]]), con = con, size = 4);
    }

}

writeArrayName <- function(txtFile, con)
## given the text file to be read, extract the array name by removing ".txt"
## and any path at the front.  Then write the name to the binary file.
{  
    tmp <- strsplit(txtFile, "\\.")[[1]][1];
    tmp <- strsplit(tmp, .Platform$file.sep)[[1]]
    name <- tmp[length(tmp)];
    writeBin(name, con = con);

}

writeCoordinates <- function(coordinates, con, twoChannel, nBytes, useOffset = FALSE, base2 = FALSE) {
 
    ## formating to deal with cases where there is only one bead
    if(twoChannel) 
        coords <- matrix(coordinates, ncol = 4)
    else {
        coords <- matrix(coordinates, ncol = 2);
    }

    ## is this lossless?
    if( nBytes == (ncol(coords) * 2) ) {
        writeBin(as.vector(coords[,1:ncol(coords)]), con = con, size = 4);
    }
    ## if not, start compressing
    else if(nBytes) {

        ##get the fractional parts
        frac <- coords[,1:ncol(coords)] - floor(coords[,1:ncol(coords)]);
        ## determine the number of bits required for each coordinate
        nBits <- (2 * 2^(!twoChannel) * nBytes);
        
        ## set a multiplier based on base 2 or base 10
        if(base2)
            mult <- 2^nBits
        else
            mult <- 10^(max(which(2^nBits > 10^(1:5))));           
        
        tmpInts <- round(mult * frac);
        ## deal with any cases that have been rounded to the maximal value
        ## we want to increment the integer part in this case
        if(any(tmpInts == mult)) {
            idx <- which(tmpInts == mult)
            coords[idx] = coords[idx] + 1;
            tmpInts[idx] = 0;
        }
        
        ## break those ints into blocks of 8 bits and then back to integers
        bits <- matrix(as.integer(matrix(sapply(tmpInts, FUN = intToBits), ncol = length(frac))[1:nBits,]), nrow = 8);
        ints <- .Call("bitsToInts", bits, PACKAGE = "BeadDataPackR");
          
        ## record the integer parts
        writeBin(as.integer(coords[,1:2]), con = con, size = 2); 
        if(twoChannel) {
            if(useOffset) 
                coords[,3:4] <- floor(coords[,3:4]) - floor(coords[,1:2]);
            writeBin(as.integer(coords[,3:4]), con = con, size = 2^(!useOffset) );
        }       
        
        ## now write the fractional data
        writeBin(as.integer(ints), con = con, size = 1);
    }
    else { ## if we aren't storing a fractional part, we should round/ceiling the values
        coords <- round(coords);       
        writeBin(as.integer(coords[,1:2]), con = con, size = 2);
        
        if(twoChannel) {
            if(useOffset) 
                coords[,3:4] <- coords[,3:4] - floor(coords[,1:2]);
            writeBin(as.integer(coords[,3:4]), con = con, size = 2^(!useOffset) );
        }
    }       
}

writeIntensities <- function(intensities, con) {

  ## write intensities as values between 0 and 65535
  ## if negative or have absolute value greater than 65535
  ## flag them as such

    ## identify those values needing flags and normalize the values to [0, 65535]
    neg <- (intensities < 0)
    intensities <- abs(intensities)
    large <- (intensities > 65535)
    intensities <- intensities %% 65536

    ## write the normalized intensities
    writeBin(as.integer(intensities), con = con, size = 2)
    ## write the flags
    flags <- .Call("composeIntensityFlags", as.integer(neg), as.integer(large), PACKAGE = "BeadDataPackR")
    writeBin(as.integer(flags), con = con, size = 1);
}

writeBabBody <- function(combined, con, twoChannel, nBytes, useOffset, base2, fullLocsIndex, pb) {
           
    ## use the index to create a list, each elemet having probes of one type
    divided <- split(combined, combined[,1])
    
    for(i in 1:length(divided)) {
        
        if(i %/% 1000)
            setTxtProgressBar(pb, 0.7 + (0.3 * i/length(divided)))
        
        current <- matrix(divided[[i]], ncol = 5 + (4^twoChannel))

        writeBin(c(as.integer(current[1,1]), as.integer(nrow(current))), con = con, size = 4)
        if(current[1,1] != 0) 
            writeIntensities(current[,2], con = con)
            
        ## if this is two channel write those intensities
        if(twoChannel & (current[1,1] != 0) )
            writeIntensities(current[,5], con = con);
        
        ## now record the coordinates      
        if(twoChannel) {
            writeCoordinates(current[,c(3,4,6,7)], con = con, twoChannel = twoChannel, nBytes = nBytes, useOffset = useOffset, base2 = base2);
        }
        else {
            writeCoordinates(current[,3:4], con = con, twoChannel = twoChannel, nBytes = nBytes, useOffset = useOffset, base2 = base2);
        }
        
        ## record the index of the locs file
        if(fullLocsIndex) {
            writeBin(as.integer(current[, ncol(current)-1 ]), con = con, size = 1)
            writeBin(as.integer(current[, ncol(current) ]), con = con, size = 2)
        }
        else {
            writeBin(as.integer(current[, ncol(current) ]), con = con, size = 1);
        }
          
    }
}

compressBeadData <- function(txtFile, locsGrn, locsRed = NULL, outputFile = NULL, path = NULL, nBytes = 8, base2 = TRUE, fullLocsIndex = FALSE, nrow = NULL, ncol = NULL, progressBar = TRUE) {

    message(paste("\nCompressing", strsplit(txtFile, ".txt")));
    
    if(progressBar) {
        pb <- txtProgressBar(style=3)
        setTxtProgressBar(pb, 0.01)
    }
    else { 
        pb <- NULL
    }
    
    ## set the default name for the output file if one isn't specified
    if(is.null(outputFile))
        outputFile <- paste(strsplit(txtFile, ".txt"), "bab", sep = ".");
    
    ## identify the correct path to each of the file
    if(!is.null(path)) {
        txtFile <- file.path(path, txtFile);
        locsGrn <- file.path(path, locsGrn);
        outputFile <- file.path(path, outputFile);
        if(!is.null(locsRed))
        locsRed <- file.path(path, locsRed)
    }

    ## check we aren't using crazy numbers of bytes for storing the fractional parts
    if(nBytes > 8) { nBytes = 8 }
    else if(nBytes < 0) { nBytes = 0 }

    ## is this two channel?
    if(is.null(locsRed)) {
        twoChannel = FALSE
        ## makes sure we aren't using excessive bytes in the one channel case
        if(nBytes > 4) #message("For single channel data a maximum of 4 bytes can be specified");
            nBytes <- min(4, nBytes); 
    }
    else 
        twoChannel = TRUE

    ## read the data
    txt <- readBeadLevelTextFile(txtFile);
    if(progressBar) setTxtProgressBar(pb, 0.05)
    locsGrn <- readLocsFile(locsGrn);
    if(twoChannel)
      locsRed <- readLocsFile(locsRed);

    ## check there aren't any negative coordinates.  If there are stop and inform the user
    #if( any(locsGrn < 0) || any(locsRed < 0) )
    #    stop("Negative coordinates found in .locs file\nBeadDataPackR cannot currently compress such arrays");

    if(progressBar) setTxtProgressBar(pb, 0.1)
    
    ## combine the files and identify non-decoded beads
    combined <- combineFiles(txt, locsGrn, locsRed, pb = pb);
    
    if(progressBar) setTxtProgressBar(pb, 0.5)
    
    ## if we're using the fitted grid then do it
    if(!fullLocsIndex) {
        res <- createIndices(locsGrn, ncol, nrow, pb = pb);
        ## replace coordinates with shifted ones
        shifts <- res[[3]][seq(1,length(res[[3]]), 3)]
        if(any(as.logical(shifts))) {
#             message("DEBUG: applying shifts");
#             ## find which segments need to be shifted
#             shiftIdx <- which(as.logical(shifts))
#             for(i in shiftIdx) {
#                 ## find the beads in those segments
#                 segIdx <- which( (combined[,ncol(combined)] > (i*res[[5]][4] + 1)) & (combined[,ncol(combined)] < ((i+1)*res[[5]][4])) );
#                 ## shift them appropriately
#                 combined[segIdx,4] <- combined[segIdx,4] + shifts[i];
#             }
            ## if we need to use a shift, switch to the fullLocsIndex for now
            fullLocsIndex = TRUE;
            warning("Overlapping sections found when creating ", outputFile, "\n  Full locs index used instead");
        }
        indices <- (16 * res[[2]][,1]) + res[[2]][,2];
        if(progressBar) setTxtProgressBar(pb, 0.65)
    }
    
    ## if we're using a full index, reduce its size by one byte per bead
    if(fullLocsIndex) {
      combined <- cbind(combined[, 1:(ncol(combined)-1)], matrix(sapply(combined[,ncol(combined)], reduceIndexSize), ncol = 2, byrow = TRUE))
    }
    ## otherwise order the reduced index and combine them
    else {
      indices <- indices[combined[,ncol(combined)]]
      combined <- cbind(combined, indices);
    }

    ## determine whether we can use offset coords for the red channel
    useOffset <- FALSE
    if(twoChannel) 
      useOffset <- allowOffset(combined[,c(3,4,6,7)]) & (nBytes != 8);
    
    ## open the output file
    con <- file(outputFile, "wb")

    ## write the file header
    writeBabHeader(con = con, version = 2, combined = combined, nBytes = nBytes, twoChannel = twoChannel, useOffset = useOffset, base2 = base2, indexingMethod = fullLocsIndex, res = res);

    ## write the name of the array
    writeArrayName(txtFile, con = con);
  
    if(progressBar) setTxtProgressBar(pb, 0.7)
    
    ## write the body of the file
    writeBabBody(combined, con = con, twoChannel = twoChannel, nBytes = nBytes, useOffset = useOffset, base2 = base2, fullLocsIndex = fullLocsIndex, pb = pb);     
    close(con);
    
    if(progressBar) {
        setTxtProgressBar(pb, 1);
        close(pb);
    }
    
    return(invisible(TRUE))
}

## ----style-knitr, eval=TRUE, echo=FALSE, results="asis"--------------------
BiocStyle::latex()

## ----Loading, eval=TRUE, echo = TRUE---------------------------------------
    library(BeadDataPackR)
    dataPath <- system.file("extdata", package = "BeadDataPackR")
    tempPath <- tempdir()

## ----Compress, eval=FALSE, echo = TRUE-------------------------------------
#     compressBeadData(txtFile = "example.txt", locsGrn = "example_Grn.locs",
#                      outputFile = "example.bab", path = tempPath, nBytes = 4,
#                      nrow = 326, ncol = 4)

## ----Decompress, eval=FALSE------------------------------------------------
#     decompressBeadData(inputFile = "example.bab", inputPath = tempPath,
#                        outputMask = "restored", outputPath = tempPath,
#                        outputNonDecoded = FALSE, roundValues = TRUE )

## ----readCompressed, eval = FALSE------------------------------------------
#   readCompressedData(inputFile = "example.bab", path = tempPath,
#                      probeIDs = c(10008, 10010) )

## ----extractLocsFile, eval = FALSE-----------------------------------------
#   locs <- extractLocsFile(inputFile = "example.bab", path = tempPath)

## ----sessionInfo, eval=TRUE------------------------------------------------
sessionInfo()

writeLocsFile <-
function(fileName, coords, nBeads)
{
    con <- file(fileName, "wb");
    writeBin(as.integer(c(1, 0, nBeads)), con = con, size = 4);
    writeBin(as.vector(coords), con = con, size = 4);
    close(con);
}

bitsToInt <- function(bits) {  
    return(sum(2^(0:7) * bits))
}

convertTo2Ints <- function(num) {

  res <- NULL;
  res[2] <- num %% 16;
  res[1] <- (num - res[2]) / 16;
  return(res);
}

reformInt <- function(bits) { 
    ## converts a sequence of bits into an integer
    n <- length(bits) - 1;
    return(sum(2^(0:n) * bits));
}


allowOffset <- function(data) {

    ## determine whether the red and green coords are close enough
    ## to store a shift, rather than the red coords themselves.
    x <- max(abs(data[,1] - data[,3])) < 128;
    y <- max(abs(data[,2] - data[,4])) < 128;
  
    return(x & y);
}

reformCoordinates <- function(coords, nSegs, marks) {

  ## take the coordinates that have been shifted and alter them back to how they were originally

  for(i in 1:nSegs) {

    if(marks[(3 * i) - 2]) {
      idx <- which( (coords[,2] >= marks[(3 * i) - 1]) & (coords[,2] <= marks[(3 * i)] ) )
      coords[idx,2] <- coords[idx,2] - marks[(3 * i) - 2];
    }
  
  }
  return(coords);
}

numberOfChannels <- function(file, sep = "\t") {
    lines <- read.table(file, sep = sep, nrows = 2);
    if(ncol(lines) == 4) ##one channel
        return(1)
    else if(ncol(lines) == 7) ##two channel 
        return(2)
    else ##unexpected number of columns
        return(0)
}

readLocsFile <- function(fileName, verbose = FALSE) {
    if(verbose)
        message(paste("Reading:", fileName));
    con <- file(fileName, "rb")
    
    ##read the first two bytes
    readBin(con, integer(), n = 2, size = 4)
    ##3rd byte tells you how many probes there are
    nprobes <- readBin(con, integer(), n = 1, size = 4)
    
    coords <- matrix(ncol = 2, nrow = nprobes)
    colnames(coords) <- c("X", "Y")
    ##read in the whole file
    tmp <- readBin(con, double(), n = 2*nprobes, size = 4)
    ##store the x and y coords in the two columns
    coords[,1] <- tmp[seq(1, 2*nprobes, 2)]
    coords[,2] <- tmp[seq(2, 2*nprobes, 2)]

    close(con)
    return(coords)
}

readBeadLevelTextFile <- function(file, sep = "\t", verbose = FALSE) {
    
    channels <- numberOfChannels(file, sep = sep);
    if(verbose)
        message(paste("Reading", file));
    if(channels == 1) 
        data <- matrix(unlist(scan(file, sep = "\t", what = list(integer(), integer(), numeric(), numeric()), skip = 1, quiet = TRUE)), ncol = 4)
    else if (channels == 2)
        data <- matrix(unlist(scan(file, sep = "\t", what = list(integer(), integer(), numeric(), numeric(), integer(), numeric(), numeric()), skip = 1, quiet = TRUE)), ncol = 7)
    else
        stop("Unknown input format!\nExpected 4 columns for single channel data or 7 columns for two channel data\n");
    
    return(data);
}

%\VignetteIndexEntry{BeadDataPackR Vignette}
%\VignetteDepends{}
%\VignetteKeywords{BeadDataPackR Illumina Microarray Compression}
%\VignettePackage{BeadDataPackR}
%\VignetteEngine{knitr::knitr}
\documentclass{article}

%\usepackage{hyperref}
%\usepackage{Sweave}
\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\Rfunarg}[1]{{\texttt{#1}}}

\newcommand{\classdef}[1]{
  {\em #1}
}

<<style-knitr, eval=TRUE, echo=FALSE, results="asis">>=
BiocStyle::latex()
@

\begin{document}
%\SweaveOpts{concordance=TRUE}
\title{\Rpackage{BeadDataPackR}: Compression Tools for Raw Illumina Beadarray Data}

\author{Mike L. Smith and Andy G. Lynch}

\maketitle



\section*{Introduction}

Raw Illumina BeadArray data consists of \textit{.tif} images produced by the scanner, accompanied by \textit{.txt} and \textit{.locs} files containing details of bead locations and their intensities within the image.  For a single channel human expression array these data typically occupy $\approx$ 125MB of storage.  The size of these files can prove a hinderance to both their storage and distribution.  Whilst the images can be compressed using a variety of common tools, the \Rpackage{BeadDataPackR} package aims to provide tools for the efficient compression of the \textit{.txt} and \textit{.locs} files.\\

\noindent Disclaimer:  \Rpackage{BeadDataPackR} has been tested on data from a variety of Illumina BeadArray platforms and, to the best of our knowledge, data compressed using lossless settings has always been restored successfully.  However, we cannot take responsibility for any loss or damage to data that results from its use.

\subsection*{Citing the package}

If you make use of \Rpackage{BeadDataPackR} to ease distribution of your data please cite the following paper:\\

\noindent BeadDataPackR: A Tool to Facilitate the Sharing of Raw Data from Illumina BeadArray Studies. \textit{Cancer Informatics}, 9:217-227, 2010.

\subsection*{iScan Data}

Bead-level data from Illumina's iScan system comes in a different format to that from the older BeadScan system.  The primary difference is that for each array section two images and accompanying \textit{.locs} files are produced, labelled Swath1 and Swath2, along with a single \textit{.txt}.  \Rpackage{BeadDataPackR} is currently unable to compress data in this format.

\section*{Compressing Data}
The first step before using any of the functionality is to load the package.  For the purpose of this vignette we also get the path to the example data that is distributed with the package.

<<Loading, eval=TRUE, echo = TRUE>>=
    library(BeadDataPackR)
    dataPath <- system.file("extdata", package = "BeadDataPackR")
    tempPath <- tempdir()
@

\Rpackage{BeadDataPackR} has two primary functions, namely to compress raw Illumina data, or decompress a file already created with the package.  We'll begin with file compression, which is carried out using the following commands:

<<Compress, eval=FALSE, echo = TRUE>>=
    compressBeadData(txtFile = "example.txt", locsGrn = "example_Grn.locs", 
                     outputFile = "example.bab", path = tempPath, nBytes = 4, 
                     nrow = 326, ncol = 4)
@


The \Rfunarg{txtFile} and \Rfunarg{locsGrn} arguments specify the names of the files to be compressed.  For two channel data there is an additional argument, \Rfunarg{locsRed}, giving the name of the \textit{.locs} file for the red channel.  These files should be found within the directory specified in the \Rfunarg{path} argument.  A future revision of the package will hopefully alter this behaviour, so all arrays within a specified folder will be automatically identified and compressed.

The argument \Rfunarg{nBytes} specifies how many bytes should be used to store the fractional parts of the bead coordinates. For a single channel array the maximum value is 4 (8 for a two channel array).  If the maximum value is used the coordinates are stored in the \textit{.bab} file as single precision floating point numbers, as they are in the \textit{.locs} files.  If a value smaller than the maximum is choosen then the integer parts of each coordinate are stored seperately.  The requested number of bytes are then used to store the fractional parts, with a corresponding loss of precision as the number of bytes decreases.

The \Rfunarg{nrow} and \Rfunarg{ncol} arguments can normally be left blank.  They specify the dimensions of each grid segment on the array and, if left blank, can normally be infered from the grid coordinates.  However, this can fail for particularly small grids or cases of misregistration where segments overlap.  If one wants or needs to specify them explicitly, these values can be found in the \textit{.sdf} which accompanies the bead level output from the scanner.  The number of columns and rows per segment can be found within the tags \texttt{<SizeGridX>} and \texttt{<SizeGridY>} respectively.

\section*{Decompressing Data}

To decompress a \textit{.bab} file that was created by \Rpackage{BeadDataPackR}, use the following function:

<<Decompress, eval=FALSE>>=
    decompressBeadData(inputFile = "example.bab", inputPath = tempPath, 
                       outputMask = "restored", outputPath = tempPath, 
                       outputNonDecoded = FALSE, roundValues = TRUE )
@

The \Rfunarg{inputFile} argument specifies the name of the \textit{.bab} that should be decompressed.  This file should be located in the folder indicated by \Rfunarg{inputPath}, which by default is the current working directory.

When an array is compressed its name is stored in the resulting \textit{.bab} file.  By default when it is decompressed this name is used for the restored files.  However, this can be troublesome if you don't want to overwrite an exisiting file.  The \Rfunarg{outputMask} argument allows the user to define the names of the restored \textit{.txt} and \textit{.locs} files.  In this case the restored files will be named `restored.txt' and `restored\_Grn.locs'.  If this was two channel data a further file, `restored\_Red.locs', would also be produced.  The files are created in the location specified by the \Rfunarg{outputPath} argument.  If this is left blank the current working directory is used.

The \textit{.txt} file that are produced by Illumina's scanner do not included the locations of beads that failed their decoding process.  Since their location are retained in the \textit{.locs} file, we have to option of including them in the restored files. \Rfunarg{outputNonDecoded} toggles whether to include them or not.  Illumina's \textit{.txt} files also give the bead centre coordinates to 7 significant figures, resulting in a different number of decimal places as we move across the array, rather than the single precision values held in the \textit{.locs} files.  \Rfunarg{roundValues} allows the user to choose between mimicing this behaviour when recreating the \textit{.txt} files or ouputing the maximum available precision.  The default for both these arguments is to reproduce the original Illumina files.

\subsection*{Extracting data directly}

Rather than decompressing the \textit{.bab} file into the two original files, it may be useful to extract data directly from it.  This can be achieved in the following way:

<<readCompressed, eval = FALSE>>=
  readCompressedData(inputFile = "example.bab", path = tempPath, 
                     probeIDs = c(10008, 10010) )
@

This function takes a \textit{.bab} file found in the directory specified by the \Rfunarg{path} argument.  In this case it extracts the data relating to the beads with IDs 10008 and 10010, which is returned as a matrix in the same format as the \textit{.txt} file that would be created if the file were to be decompressed.  If the \Rfunarg{probeIDs} argument is left NULL then a matrix containing data for every probe on the array is returned (including the non-decoded beads).  This mechanism is used within the \Rpackage{beadarray} package, from version \texttt{2.1.11}, to read compressed data directly from \textit{.bab} file into \Rpackage{beadarray} for analysis.\\

Similarly, we can extract the information contained in the original \textit{.locs} file, i.e. the bead centre coordinates in \textit{.locs} file order, by using the following command:

<<extractLocsFile, eval = FALSE>>=
  locs <- extractLocsFile(inputFile = "example.bab", path = tempPath)
@

Using coordinates in the grid order provided by the \textit{.locs} can be useful for quickly determining neighbouring beads and is used in several instances by the \Rpackage{beadarray} package.

\newpage
\section*{Session Info}

Here is the output of \Rfunction{sessionInfo} on the system on which
this document was compiled:
<<sessionInfo, eval=TRUE>>=
sessionInfo()
@

\end{document}

\name{extractLocsFile}
\alias{extractLocsFile}

\title{
    Retrieve only the .locs file information
}
\description{
    Provides a mechanism to extract the information from the original .locs file from a compressed .bab file, without the need to extract the intensity or probe ID values.
}
\usage{
extractLocsFile(inputFile, path = ".")
}

\arguments{
\item{inputFile}{
    The name of the .bab file to be read in.
}
\item{path}{
    Path to where the input file can be found.  Default is the current working directory.
}
}

\value{
    A matrix with two columns (four if two-channel data) containing the X and Y values of the bead centre coordinates supplied in the original .locs file.  For two-channel data the first two columns contain the coordinates from the green channel, with the red channel held in columns three and four.
}


\author{
    Mike L. Smith
}

\examples{
 
    dataPath <- system.file("extdata", package = "BeadDataPackR")   
    locs <- extractLocsFile(inputFile = "example.bab", path = dataPath)
    locs[1:10,]
}

\keyword{ IO }

\name{example}
\alias{example}
\docType{data}
\title{Example bead-level data}
\description{
Example bead-level data consisting of a \code{.txt} file, a \code{.locs} file and the \code{.bab} file that is produced from their compression.
}

\keyword{datasets}

\name{decompressBeadData}
\alias{decompressBeadData}

\title{
    Decompress a file in the beadarray binary format
}
\description{
    Decompressed a file create by BeadDataPackR.  The original files that were compressed will be restored as accurately as possible, depending upon the degree of precision specified during the compression.
}
\usage{
decompressBeadData(input, inputPath = ".", outputMask = NULL, outputPath = ".",
                   outputNonDecoded = FALSE, roundValues = TRUE, progressBar = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
\item{input}{
    The name of the .bab file(s) to be read.  Can be a vector of file names, such as generated by \code{list.files()}.
}
\item{inputPath}{
    Path where the compress file is located.  The default is to use the current working directory.
}
\item{outputMask}{
    Text specify the names of the output files.  The output files will have ".txt", "_Grn.locs" and (if approriate "_Red.locs") appended to this mask.  If left NULL the original names of the section will be used.
}
\item{outputPath}{
    Path to where the uncompressed version of the files should be written to.  The default is to use the current working directory.
}
\item{outputNonDecoded}{
    If TRUE the undecoded beads will be included in the output .txt file.  They will have ProbeID 0 and intensity 0, but the bead centre coordinates will be included.
}
\item{roundValues}{
    The original Illumina text files give the bead centre coordinates to 7 significant figures.  When this argument is TRUE decompressed files are also truncated in this manner, whilst FALSE writes them to the full precision they are stored in the compressed file.
}
\item{progressBar}{
    By default the function uses a \code{\link[utils]{txtProgressBar}} to indicate progress through the compression.  Setting this argument to FALSE supresses the drawing of this progress bar.
}
}

\value{
    Called primarily for its side effect, in which two (or three) files are written to the disk.  These files should be representative of the original files that were compressed.  The function returns, invisibly, the number of lines written in the .txt file.
}

\author{
    Mike L. Smith
}

\examples{ 
    dataPath <- system.file("extdata", package = "BeadDataPackR")
    decompressBeadData(input = "example.bab", inputPath = dataPath, outputPath = tempdir())
}

\keyword{ IO }

\name{readCompressedData}
\alias{readCompressedData}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
    Extract data for specific bead-types from a compressed file
}
\description{
    Given a list of probeIDs this function can scan a compressed .bab file for matching entries and return the data as a data.frame within R, rather than decompressing the data and generating new files.
}
\usage{
readCompressedData(inputFile, path = ".", probeIDs = NULL)
}

\arguments{
\item{inputFile}{
    The name of the .bab file to be read in.
}
\item{path}{
    Path to where the input file can be found.  Default is the current working directory.
}
\item{probeIDs}{
    List the probe IDs for which data should be obtained.  If left NULL then every probe on the array is returned.
}
}

\value{
    If the requested probe IDs are present the function returns a data.frame with one row per bead.  If the probes are not found in the file then the function returns NULL and informs the user.
}


\author{
    Mike L. Smith
}

\examples{
 
    dataPath <- system.file("extdata", package = "BeadDataPackR")   
    readCompressedData(inputFile = "example.bab", path = dataPath, probeIDs = c(10008, 10010))
}

\keyword{ IO }

\name{compressBeadData}
\alias{compressBeadData}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
    Write raw bead level data to a compressed format.
}
\description{
    Given raw bead level data, in the form of .txt and .locs file, this function combines the two producing a new file with the data stored in a compressed format.
}
\usage{
compressBeadData(txtFile, locsGrn, locsRed = NULL, outputFile = NULL,
                 path = NULL, nBytes = 8, base2 = TRUE, fullLocsIndex = FALSE,
                 nrow = NULL, ncol = NULL, progressBar = TRUE)
}

\arguments{
\item{txtFile}{
    The name of the .txt file to be read in.
}
\item{locsGrn}{
    The locs file for the green channel.
}
\item{locsRed}{
    The locs file for the red channel.  Only needed for two channel data.
}
\item{outputFile}{
    Name of the file to be created.
}
\item{path}{
    Path to where the input files can be found.  If NULL the current working directory is used.  This is also the directory where the output files will be written.
}
\item{nBytes}{
    Gives the number of bytes that are used to store the fractional parts of the bead coordinates.  For a single channel array the maximum value is 4, whilst it is 8 for a two channel array.  Any number larger than this is automatically set the the maximum value.  If the maximum value is used the coordinates are stored in the .bab file as single precision floating point numbers, as they are in the .locs files.  If a value smaller than the maximum is choosen then the integer parts of each coordinate are stored seperately.  The requested number of bytes are then used to store the fractional parts, with a corresponding loss of precision as the number of bytes decreases.
}
\item{base2}{
     If not using the full precision coordinates, the approximations can be stored as either a binary or decimal fraction.  Using a binary fraction (base2 = TRUE) provides a greater accuracy, but can lead to a meandering number of decimal places in the reconstructed .txt files.  If one wants a consistent number of decimal places, set base2 = FALSE.
}
\item{fullLocsIndex}{
    Default value of 0 uses a linear model fitted to each segment of the array to allow reconstruct the locs file when the file is decompressed.  Using a value of 1 a simple index is used to record the locs file order, but requires more space.
}
\item{ncol}{
    This specifies the number of columns in each grid segment on the array and, if left blank, can normally be infered from the grid coordinates.  However, this can fail for particularly small grids. If one wants or needs to specify them explicitly, these values can be found in the .sdf which accompanies the bead level output from the scanner.  The number of columns per segment can be found within the tag <SizeGridX>
}
\item{nrow}{
    See ncol.  If needed can be found within the <SizeGridY> tag in the .sdf file.
}
\item{progressBar}{
    By default the function uses a \code{\link[utils]{txtProgressBar}} to indicate progress through the compression.  Setting this argument to FALSE supresses the drawing of this progress bar.
}
}

\value{
    Primarily invoked for its side effect, which is to produce a compressed version of the input files. The function returns, invisibly, a logical \code{TRUE} if compression was successful.
}

\details{
    In the future the file names will be determined automatically, rather than requiring manual entry of each.  The path argument may also be amended so there are seperate options for the locations of the input and output files.
}

\author{
    Mike L. Smith
}

\examples{
 
    dataPath <- system.file("extdata", package = "BeadDataPackR")  
    ## copy the files to a temp directory, and don't overwrite system files
    file.copy( list.files(path = dataPath, pattern = "example", full.names = TRUE), 
               tempdir() )
    compressBeadData(txtFile = "example.txt", locsGrn = "example_Grn.locs", 
    outputFile = "example.bab", path = tempdir(), nBytes = 4, nrow = 326, 
    ncol = 4, fullLocsIndex = TRUE)
}

\keyword{ IO }
